//	Vamos Automotive Simulator
//  Copyright (C) 2001--2002 Sam Varner
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef _SPLINE_H_
#define _SPLINE_H_

#include <vamos/geometry/Two_Point.h>
#include <vector>

namespace Vamos_Geometry
{
  class Spline
  {
	std::vector <Two_Point> m_point_array;
	std::vector <Two_Point> m_second_deriv;
	double m_last_angle;
	double m_scale;

  public:
	Spline (const std::vector <Two_Point>& points,
			double first_angle, double last_angle, double scale);
  
	Two_Point interpolate (double t);
	// dist is the offset (+ or -) from the spline curve. 
	Two_Point interpolate (double t, double dist);
  };
}

#endif
