//	Vamos Automotive Simulator
//  Copyright (C) 2001--2002 Sam Varner
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef _TEXTURE_IMAGE_H_
#define _TEXTURE_IMAGE_H_

#include <string>
#include <fstream>

namespace Vamos_Geometry
{
  // Exception class for texture files that can't be found.
  class Missing_Texture_File
  {
	std::string m_file;
  public:
	Missing_Texture_File (std::string file) : m_file (file) {};
  };

  class Texture_Image
  {
	unsigned char* m_data;
	int m_data_size;
	int m_height;
	int m_width;
	int m_color_depth;

  public:
	Texture_Image (std::string file_name);
	Texture_Image (const Texture_Image& image);
	~Texture_Image ();

	const unsigned char* data () const { return m_data; }
	int height () const { return m_height; }
	int width () const { return m_width; }
  };

  void skip_comments (char* buffer, std::ifstream* stream);
}

#endif
