//	Vamos - a driving simulator
//  Copyright (C) 2001 Sam Varner
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef _WORLD_H_
#define _WORLD_H_

#include <vamos/track/Track.h>
#include <vamos/world/Atmosphere.h>
#include <vamos/body/Body.h>
#include <vector>

namespace Vamos_World
{
  class World
  {
  protected:
	double m_gravity;
  
	Atmosphere* mp_atmosphere;
	Vamos_Track::Track* mp_track;

	virtual void interact (Vamos_Body::Body*) = 0;

  public:
	World (double gravity, Vamos_Track::Track* track, Atmosphere* atmosphere);
	virtual ~World () {};

	virtual void start () = 0;
  };
}

#endif
